## 0.5.0-nullsafety.2
* Support for nullsafety and FFI 1.0.0
* Added macOS support
* **Minimum requirements** are Dart SDK 2.12+ and/or Flutter 2+. This release is not backwards compatible and it will likely crash on SDK < 2.12

## 0.4.0
* **(!!)** Queries now return a ResultSet object instead of a Dart list. Use `ResultSet.allResults` to get the previous behaviour.
* **(!!)** Renamed Document `jsonProperties` setter/getter to `json`
* **(+)** Document constructor's `data` accepts `FLValue`, a json string or json-encodable object as input
* **(+)** Documents now can hold a reference to the database and have `save`, `delete`, `expiration` methods
* **(+)** `FLArray` has two new constructors `fromList` and `fromJson`
* **(+)** `FLDict` has two new constructors `fromMap` and `fromJson`
* **(+)** `FLArray` and `FLDict` support keypath accessor similar to `FLValue` as `FLArray()` and `FLDict()`. Normal key access using `[]` is unchanged.
* **(+)** Implemented `CBLLog` class to manage messages that Couchbase Lite logs at runtime. Ability to control the `domain` and `level` of messages logged to either the `console`, `file` or a `callback` registered by the application.
* Fix mutable document's nested properties not being mutable
* Clean up listeners and other C callbacks implementation
* Fix database and document listeners on Android
* Fix blob `getContent` not returning the correct value
* Added tests for `Document`, `Blob` and the `Fleece` classes
* Lots of fixes and improvements in code structure and documentation

## 0.3.1
* Fix query parameter setter

## 0.3.0
* Added stream based API for Blobs
* Replicator conflict resolver
* Add keypath support for FLDict
* Fix FLDictEntryIterator not returning keys as strings
* Fix new document properties not being initialized
* Fix the way dll is included

## 0.2.0
*  **Blobs** - Added basic support for blobs
* Improve Document properties API
* Allow queries to be written as multiline strings
* Fix crash when updating already existing property of document
* Fix crash on Android when creating replicator
* Fix (live) queries not being released when removing change listeners

## 0.1.0+2
 * Moved the ffi bindings into their own library to improve the documetntation generated by dartdoc.

## 0.1.0
* **Database:** Open, Close, Copy, Compact, Delete, Batch operations, Change notifications, document change notifications, Buffered notifications
* **Document**
    CRUD - Create, Read, Udpdate, Delete, Save conflict handler, Document expiration, with automatic purge
    Fleece API for direct access to the binary data
* **Queries**
    [N1QL](https://www.couchbase.com/products/n1ql) query language, Query parameters, Explain, "Live queries" - change listener
* **Replication**
    Authentication: Basic and Session based, Pull/push filters, channels, Status listeners